namespace CMSMicroservice.Application.UserCQ.Commands.VerifyOtpToken;
public class VerifyOtpTokenCommandValidator : AbstractValidator<VerifyOtpTokenCommand>
{
    public VerifyOtpTokenCommandValidator()
    {
        RuleFor(model => model.Mobile)
            .NotEmpty();
        RuleFor(model => model.Purpose)
            .NotEmpty();
        RuleFor(model => model.Code)
            .NotEmpty();
    }
    public Func<object, string, Task<IEnumerable<string>>> ValidateValue => async (model, propertyName) =>
    {
        var result = await ValidateAsync(ValidationContext<VerifyOtpTokenCommand>.CreateWithOptions((VerifyOtpTokenCommand)model, x => x.IncludeProperties(propertyName)));
        if (result.IsValid)
            return Array.Empty<string>();
        return result.Errors.Select(e => e.ErrorMessage);
    };
}
